Canvas Events

- Main Page
- Related Pages
- Modules
- Namespaces
- Data Structures
- Files
- Examples

Modules
Canvas Events
Evas » Canvas Functions

Functions relating to canvas events, which are mainly reports on its internal states changing (an object got focused, the rendering is updated, etc). More...

## Modules
| Input Events Freezing Functions
| Functions that deal with the freezing of input event processing of an Evas canvas.
| Input Events Feeding Functions
| Functions to tell Evas that input events happened and should be processed.
void | evas_event_callback_add (Evas *e, Evas_Callback_Type type, Evas_Event_Cb func, const void *data)
| Add (register) a callback function to a given canvas event. More...
void | evas_event_callback_priority_add (Evas *e, Evas_Callback_Type type, Evas_Callback_Priority priority, Evas_Event_Cb func, const void *data)
| Add (register) a callback function to a given canvas event with a non-default priority set. More...
void * | evas_event_callback_del (Evas *e, Evas_Callback_Type type, Evas_Event_Cb func)
| Delete a callback function from the canvas. More...
void * | evas_event_callback_del_full (Evas *e, Evas_Callback_Type type, Evas_Event_Cb func, const void *data)
| Delete (unregister) a callback function registered to a given canvas event. More...
void | evas_post_event_callback_push (Evas *e, Evas_Object_Event_Post_Cb func, const void *data)
| Push a callback on the post-event callback stack. More...
void | evas_post_event_callback_remove (Evas *e, Evas_Object_Event_Post_Cb func)
| Remove a callback from the post-event callback stack. More...
void | evas_post_event_callback_remove_full (Evas *e, Evas_Object_Event_Post_Cb func, const void *data)
| Remove a callback from the post-event callback stack. More...

## Detailed Description

Functions relating to canvas events, which are mainly reports on its internal states changing (an object got focused, the rendering is updated, etc).

Some of the functions in this group are exemplified here.

## Function Documentation

void evas_event_callback_add | ( | Evas * | e,
|  | Evas_Callback_Type | type,
|  | Evas_Event_Cb | func,
|  | const void * | data
| ) |  |

Add (register) a callback function to a given canvas event.

Parameters

  e | Canvas to attach a callback to
  type | The type of event that will trigger the callback
  func | The (callback) function to be called when the event is triggered
  data | The data pointer to be passed to `func`

This function adds a function callback to the canvas `e` when the event of type `type` occurs on it. The function pointer is `func`.

In the event of a memory allocation error during the addition of the callback to the canvas, evas_alloc_error() should be used to determine the nature of the error, if any, and the program should sensibly try and recover.

A callback function must have the Evas_Event_Cb prototype definition. The first parameter (`data`) in this definition will have the same value passed to evas_event_callback_add() as the `data` parameter, at runtime. The second parameter `e` is the canvas pointer on which the event occurred. The third parameter `event_info` is a pointer to a data structure that may or may not be passed to the callback, depending on the event type that triggered the callback. This is so because some events don't carry extra context with them, but others do.

The event type `type` to trigger the function may be one of EVAS_CALLBACK_RENDER_FLUSH_PRE, EVAS_CALLBACK_RENDER_FLUSH_POST, EVAS_CALLBACK_CANVAS_FOCUS_IN, EVAS_CALLBACK_CANVAS_FOCUS_OUT, EVAS_CALLBACK_CANVAS_OBJECT_FOCUS_IN and EVAS_CALLBACK_CANVAS_OBJECT_FOCUS_OUT. This determines the kind of event that will trigger the callback to be called. Only the last two of the event types listed here provide useful event information data – a pointer to the recently focused Evas object. For the others the `event_info` pointer is going to be `NULL`.

Example:

1 evas_event_callback_add(d.canvas, EVAS_CALLBACK_RENDER_FLUSH_PRE,
2 _render_flush_cb, NULL);
3 if (evas_alloc_error() != EVAS_ALLOC_ERROR_NONE)
4 {
5 fprintf(stderr, "ERROR: Callback registering failed! Aborting.\n");
6 goto panic;
7 }
8
9 evas_event_callback_add(d.canvas, EVAS_CALLBACK_CANVAS_OBJECT_FOCUS_IN,
10 _object_focus_in_cb, NULL);
11 if (evas_alloc_error() != EVAS_ALLOC_ERROR_NONE)
12 {
13 fprintf(stderr, "ERROR: Callback registering failed! Aborting.\n");
14 goto panic;
15 } /* two canvas event callbacks */

Looking to the callbacks registered above,

1 /* called when our rectangle gets focus */
2 static void
3 _object_focus_in_cb(void *data EINA_UNUSED,
4 Evas *e,
5 void *event_info)
6 {
7 fprintf(stdout, "An object got focused: %s\n",
8 evas_object_name_get(event_info));
9
10 fprintf(stdout, "Let's recheck it: %s\n",
11 evas_object_name_get(evas_focus_get(e)));
12
13 fprintf(stdout, "And again: %s\n", evas_object_focus_get(event_info) ?
14 "OK!" : "Oops, something is bad.");
15 }
16
17 /* render flush callback */
18 static void
19 _render_flush_cb(void *data EINA_UNUSED,
20 Evas *e EINA_UNUSED,
21 void *event_info EINA_UNUSED)
22 {
23 fprintf(stdout, "Canvas is about to flush its rendering pipeline!\n");
24 }
25
26 /* put some action in the canvas */
27 static Eina_Bool
28 _resize_cb(void *data EINA_UNUSED)
29 {
30 int w, h, cw, ch;
31
32 evas_object_geometry_get(d.img, NULL, NULL, &w, &h);
33 ecore_evas_geometry_get(d.ee, NULL, NULL, &cw, &ch);
34
35 if (w < cw)
36 evas_object_resize(d.img, cw, ch);
37 else
38 evas_object_resize(d.img, cw / 2, ch / 2);
39
40 return EINA_TRUE; /* re-issue the timer */
41 }
42
43 /* let's have our events back */

we see that the canvas flushes its rendering pipeline (EVAS_CALLBACK_RENDER_FLUSH_PRE) whenever the `_resize_cb` routine takes place: it has to redraw that image at a different size. Also, the callback on an object being focused comes just after we focus it explicitly, on code.

See the full example.

Note
  Be careful not to add the same callback multiple times, if that's not what you want, because Evas won't check if a callback existed before exactly as the one being registered (and thus, call it more than once on the event, in this case). This would make sense if you passed different functions and/or callback data, only.

References EVAS_CALLBACK_PRIORITY_DEFAULT, and evas_event_callback_priority_add().

void evas_event_callback_priority_add | ( | Evas * | e,
|  | Evas_Callback_Type | type,
|  | Evas_Callback_Priority | priority,
|  | Evas_Event_Cb | func,
|  | const void * | data
| ) |  |

Add (register) a callback function to a given canvas event with a non-default priority set.

Except for the priority field, it's exactly the same as evas_event_callback_add

Parameters

  e | Canvas to attach a callback to
  type | The type of event that will trigger the callback
  priority | The priority of the callback, lower values called first.
  func | The (callback) function to be called when the event is triggered
  data | The data pointer to be passed to `func`

See also
  evas_event_callback_add

Since
  1.1

References eina_inlist_append(), EINA_INLIST_GET, and eo_data_scope_get().

Referenced by evas_event_callback_add().

void* evas_event_callback_del | ( | Evas * | e,
|  | Evas_Callback_Type | type,
|  | Evas_Event_Cb | func
| ) |  |

Delete a callback function from the canvas.

Parameters

  e | Canvas to remove a callback from
  type | The type of event that was triggering the callback
  func | The function that was to be called when the event was triggered

Returns
  The data pointer that was to be passed to the callback

This function removes the most recently added callback from the canvas `e` which was triggered by the event type `type` and was calling the function `func` when triggered. If the removal is successful it will also return the data pointer that was passed to evas_event_callback_add() when the callback was added to the canvas. If not successful `NULL` will be returned.

Example:

1 extern Evas *e;
2 void *my_data;
3 void focus_in_callback(void *data, Evas *e, void *event_info);
4
5 my_data = evas_event_callback_del(ebject, EVAS_CALLBACK_CANVAS_FOCUS_IN, focus_in_callback);

References EINA_INLIST_GET, eina_inlist_remove(), EINA_INLIST_REVERSE_FOREACH, and eo_data_scope_get().

void* evas_event_callback_del_full | ( | Evas * | e,
|  | Evas_Callback_Type | type,
|  | Evas_Event_Cb | func,
|  | const void * | data
| ) |  |

Delete (unregister) a callback function registered to a given canvas event.

Parameters

  e | Canvas to remove an event callback from
  type | The type of event that was triggering the callback
  func | The function that was to be called when the event was triggered
  data | The data pointer that was to be passed to the callback

Returns
  The data pointer that was to be passed to the callback

This function removes the first added callback from the canvas `e` matching the event type `type`, the registered function pointer `func` and the callback data pointer `data`. If the removal is successful it will also return the data pointer that was passed to evas_event_callback_add() (that will be the same as the parameter) when the callback(s) was(were) added to the canvas. If not successful `NULL` will be returned. A common use would be to remove an exact match of a callback.

Example:

1 evas_event_callback_del_full(evas, EVAS_CALLBACK_RENDER_FLUSH_PRE,
2 _render_flush_cb, NULL);
3 evas_event_callback_del_full(
4 evas, EVAS_CALLBACK_CANVAS_OBJECT_FOCUS_IN,
5 _object_focus_in_cb, NULL);

See the full example.

Note
  For deletion of canvas events callbacks filtering by just type and function pointer, user evas_event_callback_del().

Examples:
  ecore_imf_example.c, and evas-events.c.

References EINA_INLIST_FOREACH, EINA_INLIST_GET, eina_inlist_remove(), and eo_data_scope_get().

void evas_post_event_callback_push | ( | Evas * | e,
|  | Evas_Object_Event_Post_Cb | func,
|  | const void * | data
| ) |  |

Push a callback on the post-event callback stack.

Parameters

  e | Canvas to push the callback on
  func | The function that to be called when the stack is unwound
  data | The data pointer to be passed to the callback

Evas has a stack of callbacks that get called after all the callbacks for an event have triggered (all the objects it triggers on and all the callbacks in each object triggered). When all these have been called, the stack is unwound from most recently to least recently pushed item and removed from the stack calling the callback set for it.

This is intended for doing reverse logic-like processing, example - when a child object that happens to get the event later is meant to be able to "steal" functions from a parent and thus on unwind of this stack have its function called first, thus being able to set flags, or return 0 from the post-callback that stops all other post-callbacks in the current stack from being called (thus basically allowing a child to take control, if the event callback prepares information ready for taking action, but the post callback actually does the action).

References eina_list_prepend(), and eo_data_scope_get().

void evas_post_event_callback_remove | ( | Evas * | e,
|  | Evas_Object_Event_Post_Cb | func
| ) |  |

Remove a callback from the post-event callback stack.

Parameters

  e | Canvas to push the callback on
  func | The function that to be called when the stack is unwound

This removes a callback from the stack added with evas_post_event_callback_push(). The first instance of the function in the callback stack is removed from being executed when the stack is unwound. Further instances may still be run on unwind.

References EINA_LIST_FOREACH, and eo_data_scope_get().

void evas_post_event_callback_remove_full | ( | Evas * | e,
|  | Evas_Object_Event_Post_Cb | func,
|  | const void * | data
| ) |  |

Remove a callback from the post-event callback stack.

Parameters

  e | Canvas to push the callback on
  func | The function that to be called when the stack is unwound
  data | The data pointer to be passed to the callback

This removes a callback from the stack added with evas_post_event_callback_push(). The first instance of the function and data in the callback stack is removed from being executed when the stack is unwound. Further instances may still be run on unwind.

References EINA_LIST_FOREACH, and eo_data_scope_get().